#include "stm32f10x.h"
#include "sys.c"
#include "io.c"
#include "i3202lcd.c"
#include "ov9640.c"


void histogram(unsigned char * luminance)
{
   unsigned char n,m;
              
   for(n=0;n<128;n++) luminance[n]=luminance[n]>>1;  // divide by 2
   
   LcdSetWindow(160+10,60,128,120);
   LcdDataStart();
   for(m=0;m<120;m++)
    {  for(n=0;n<128;n++)
         {    
              if(luminance[n]<m) {  LcdDataWrite(0xffff); }
              else  {  LcdDataWrite(0x0000); }
         }
    }             
   LcdDataEnd();
   
}

int main(void)
{       
  unsigned long n;
  unsigned char i,j;     
  unsigned char Y,UV;
  unsigned char luminance[128];
  
  gpio_init();
  rcc_init();  
  uart_init1();

  mdelay(1000);  // wait for flash loader communication...
  put_string1("\nCAM Y Histogram");
  
  LcdInit();                
  LcdBl_H;  
  LcdSetDirection(90);
  
  LcdSetWindow(0,0,320,240);
  LcdDataStart();
  for(n=0;n<(320*240);n++) LcdDataWrite(0xffff);
  LcdDataEnd();
  
  LcdSetWindow(0,60,160,120);

  EnableAutoSetCM(); 
  SetYUVQQVGA();     // YUV   160*120

  while(1)
  {              
       CmReady_H;  CmReady_L;
       CmCapture_H;  CmCapture_L;

       histogram(luminance);
       for(i=0;i<128;i++) luminance[i]=0;

       while(CmEndCapture==0);  
       CmReady_H;  CmReady_L;
                     
       LcdSetWindow(0,60,160,120);
       LcdDataStart();
       for(i=0;i<160;i++)
         {
            for(j=0;j<120;j++)
              {
                 CmRdData_H; CmRdData_H; 
                 Y=CmData;
                 CmRdData_L;

                 CmRdData_H; CmRdData_H;
//                 UV=CmData;
                 CmRdData_L;
                 
                 LcdDataWrite(Y>>3);        
                
                 Y=Y>>1; 
                 if(luminance[Y]<240) luminance[Y]++;
               }
           }
       LcdDataEnd(); 
  }

}